
{*******************************************************}
{                                                       }
{       4th GUI Library for Delphi                      }
{       Components Registration Unit                    }
{                                                       }
{       Copyright (C) 1996,2001 Sergey S. Tkachenko     }
{       e-mail: tkachenko@360.com.ua                    }
{          Web: www.4thfebruary.f2s.com                 }
{                                                       }
{*******************************************************}

unit Reg4GUI;

{$I FTHVER.INC}

interface

uses 
  Classes, 
{$IFNDEF DELPHI4_UP}
  DsgnIntf,
{$ENDIF}
  FthSBar, FthTabs, FthBtns, FthImage, FthHint;

{$IFNDEF DELPHI4_UP}
type
  TFourthShortcutBarEditor = class(TComponentEditor)
  protected
    procedure GetPropEdit(Editor: TPropertyEditor);
  public
    procedure Edit; override;
  end;
{$ENDIF}

procedure Register;

implementation

{$IFNDEF DELPHI4_UP} 

uses TypInfo; 

procedure TFourthShortcutBarEditor.GetPropEdit(Editor: TPropertyEditor);
begin
  if Editor.GetName = 'Buttons' then Editor.Edit;
end;

procedure TFourthShortcutBarEditor.Edit;
var
  List: {$IFDEF DELPHI5_UP} TDesignerSelectionList {$ELSE} TComponentList {$ENDIF};
begin
  {$IFDEF DELPHI5_UP}
  List := TDesignerSelectionList.Create;
  {$ELSE}
  List := TComponentList.Create;
  {$ENDIF}
  try
    List.Add(Component);
    GetComponentProperties(List, [tkClass], Designer, GetPropEdit);
  finally
    List.Free;
  end;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('4th GUI', [
    TFourthShortcutBar,         { fthsbar.pas }
    TFourthTabSet,              { fthtabs.pas }
    TFourthStandardButton,      { fthbtns.pas }
    TFourthImage,               { fthimage.pas }
    TFourthHintPanel            { fthhint.pas }
  ]);
{$IFNDEF DELPHI4_UP}
  RegisterComponentEditor(TFourthShortcutBar, TFourthShortcutBarEditor);
{$ENDIF}
end;

end.

