{
JwPackage - v1.02

        When I started learning how to do components, I really did start with
a Corriolis book and a few "stupid" ideas.  Namely, the TSmilie and the TLinez.
(I actually started using the TLinez because I didn't like the behavior of the
TBevel--And I was able to get a nice 3-D look out of it...).  Then I started
moving on to making components that actually solved a problem of some sort.  At
first I was working as if I wasn't sure if I was going to be "backwards compatable"
with Delphi 1 and Delphi 3-5, but over time it became ridiculous.  Also, I was
unsure if I was going to use each one over another, so I did actually duplicate
a lot of code between each unit--it took me some time to decide on a "Package"
solution.  But I have actually used many of these components in my software, so
I hope other might find them useful.  I packed the "register" unit here so that if
there is any one that is "undesired" (you know, I would LOVE for someone to use
my JwSmile in some sort of application--even as an easter egg...) just comment it
out here, and your done.
   Here's a breif overview of what I did and what I was thinking:

     JwAutAbt:
  This is a non-visual component to encapsulate an "About" box.  At the time, I was
attempting to meet a ISO900X standard, so I added lotsa of info.

     JwBinRES:
  I really never liked Res files and there are some cases where it's much easier to
just drop a extra file into a component so it can just be included into the DFM file.
That was exactly what I did with the BMPRes and such, but for the longest time I couldn't
figure out how.  Now this component will not only take ANY file even if it is binary
and allow it to be converted to a TMemoryStream.  PERFECT for the Abrevia unit and
zip files (that's from Turbo Power if you didn't know--it ain't cheap either!)

     JwBmpRes:
  I never liked the idea of dropping components just to set the component to VISIBLE=False.
It just seemed too sloppy for me.  So I created this non-visual component that just stored
the TGraphic, since Delphi came with all sorts of component editors for that sort of thing
already.

     JwByPs:
  One programmer who worked for me needed to have a checkbox that had a behavior that would
allow him to prevent a "Click" even tho it was enabled.  The exact reason escapes me right
now, but it made sence then.  You must admit, ENABLED=FALSE on TWinControls behave very
differently.

     JwFshCl:
  I kept seeing these CD Menus that had static labels that behaved like url links--they
"Flared" out when the mouse was over it.  I really liked the idea, since you can always
add an event to a TLabel, but how's the user going to know it has that behavior?  By
having this event, the user has some sort of signal.  I used this 3-Staged event
behavior on a lot of cases.

     Jwfshpn:
  I did this one just like the JwFshCl except on a TPanel so I could create an ActiveX
control to import into Access.  I did it, but I wasn't able to make it work with the
Access reports...ah well.

     JwLabel:
  This is just a TLabel, but with total access to the font itself.  I didn't really want
to mess to much with it, so I added some.. fixes.. to make a rotated font in the window.

     JwLinez:
  I think in every example or book on Components starts with the drawing of a line.  I
actually started using this in apps to created a sort of 3-D effect.

     JwPopbtn:
  This one didn't turn out that well, but it was supposed to "Popup" whenever the mouse
was over the component.  It was a bit messy with "unexpected" or "random" events.

     JwRotPan:
  This just made a JwLabel for a TPanel.  Again, for ActiveX stuff.

     Jwrtfsh:
  This is a Combination of JwLabel and JwFshCl.

     jwShellBrowseFolder:
  This is a browse for folder using the call to SHBrowseForFolder.  Unfortunatly, it doesn't
work exactly as I wanted.  I need more research into the whole conversion of C++ to Delphi.

     JwSmile:
  You know, I just wanted to know if I could do it.

     JwStgPnl:
  I wanted a 3-staged button, or at least a panel that had three states that I could
test easily.  It could be easily done in code, but I figured that I should make it into
a component.

     JwStrRes:
  Much like the BinRes and BmpRes, this is a non-visual component to store text.

     JwWrpbtn:
  I really wanted to have a button that had some of the behaviors of the TLabel, so I
created a TLabel that had the painting behaviors of the TButton.   Again, this didn't work
out as close as I would have liked.

  I give this source as freeware with no assurances or warentees involved.  Use at your own risk.
Anyone can use this code for any project you wish, however I humbly request that my name and email
address be given somewhere in the credits.
  My contact info is:

Joseph Wilcock
Coockoo@hotmail.com
http://msnhomepages.talkcity.com/RedmondAve/coockoo/

  PS:  When you read the comments in the source, please remember that I did these over
    a great span of time--I've changed my styles and "Programming Superstions" since.
}

{
        ** OVERALL VERSION History   **
   Version     Date     Notes
    v1.00  - 01APR99    Original Release
    v1.01  - 12Dec00    Added StrRes, BmpRes, RotPan, ByPass
    v1.02  - ???????    I don't know why I do this--I keep forgetting
                        to update this thing.
}

unit JoeReg;

interface

uses JwAutAbt,            // Non-visual auto "About" box with various properties
     JwBinRES,            // Streamable Binary Resource (alternative to Res files)
     JwBmpRes,            // Non-visual Component to store TGraphics with little memory
     JwByPs,              // "Checkbox By Pass" - Prevent a click even if enabled
     JwFshCl,             // TLabel with Three different fonts for different states
     Jwfshpn,             // As a "TFlashClick" but on a TPanel
     JwLabel,             // TLabel with a absolute control over the font's values, including rotation
     JwLinez,             // Very simple line drawing tool
     JwPopbtn,            // Button with "three" stages--to react to the mouse-over event
     JwRotPan,            // Just like the JwLabel, but on a TPanel--can be imported to ActiveX
     Jwrtfsh,             // Combination of JwLabel, JwFshCl
     jwShellBrowseFolder, // Non-Visual Browsing for directories, using the Windows Shell
     JwSmile,             // Useless component--just for fun
     JwStgPnl,            // Three stage panel--encapsulates what can be done by adding events.
     JwStrRes,            // Non-Visual Resource for TStrings
     JwWrpbtn             // TLabel with TButton-style look and feel.
     ;

procedure Register;

implementation

Procedure Register;
begin
  JwLinez.Register;
  JwLabel.Register;
  JwSmile.Register;
  JwWrpbtn.Register;
  JwPopbtn.Register;
  JwFshCl.Register;
  Jwfshpn.Register;
  JwStgPnl.Register;
  Jwrtfsh.Register;
  JwAutAbt.Register;
  JwRotPan.Register;
  JwStrRes.Register;
  JwBmpRes.Register;
  JwByPs.Register;
  JwBinRES.Register;
end;



end.
