//  Version History
//     Num     Date               Notes
//     1.00  December 12, 2000   Initial Release

//  Created By:
//    Joseph Wilcock
//    Coockoo@hotmail.com
//    http://msnhomepages.talkcity.com/RedmondAve/coockoo/


unit JwByPs;

interface

uses Messages, SysUtils, Classes, Controls, Forms, Graphics,
     Stdctrls, Windows;

type
  TOnPreClickEvent = Function( Sender: TObject; CurrentState: TCheckBoxState ): boolean of Object;

  TJwByPass = class(TCustomCheckBox)
    private
      FAllowCheck : Boolean;
      FOnPreClickEvent: TOnPreClickEvent;
    protected
      procedure Click; override;
      procedure KeyPress(var Key : Char); override;
      procedure Loaded; override;
      procedure Toggle; override;
    public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
    published
      // I did this in order to import as many options as possible.
      property Action;
      property Alignment;
      property AllowGrayed;
      property Anchors;
      property BiDiMode;
      property Caption;
      property Checked;
      property Color;
      property Constraints;
      property Ctl3D;
      property DragCursor;
      property DragKind;
      property DragMode;
      property Enabled;
      property Font;
      property ParentBiDiMode;
      property ParentColor;
      property ParentCtl3D;
      property ParentFont;
      property ParentShowHint;
      property PopupMenu;
      property ShowHint;
      property State;
      property TabOrder;
      property TabStop;
      property Visible;
      property OnClick;
      property OnContextPopup;
      property OnDragDrop;
      property OnDragOver;
      property OnEndDock;
      property OnEndDrag;
      property OnEnter;
      property OnExit;
      property OnKeyDown;
      property OnKeyPress;
      property OnKeyUp;
      property OnMouseDown;
      property OnMouseMove;
      property OnMouseUp;
      property OnStartDock;
      property OnStartDrag;
      property AllowCheck : Boolean
           read FAllowCheck write FAllowCheck
           default True;
      property OnPreClickEvent: TOnPreClickEvent
           Read FOnPreClickEvent Write FOnPreClickEvent;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('JwTools', [TJwByPass]);
end;

procedure TJwByPass.Click;
begin
  inherited Click;
end;

procedure TJwByPass.KeyPress(var Key : Char);
const
  TabKey = Char(VK_TAB);
  EnterKey = Char(VK_RETURN);
begin
  inherited KeyPress(Key);
end;

constructor TJwByPass.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FAllowCheck := False;
  FOnPreClickEvent := nil;
end;

destructor TJwByPass.Destroy;
begin
  inherited Destroy;
end;

procedure TJwByPass.Loaded;
begin
  inherited Loaded;
end;

procedure TJwByPass.Toggle;
begin
  if Assigned( FOnPreClickEvent ) then
    FAllowCheck := FOnPreClickEvent( Self, State );
  if FAllowCheck then
    begin
      case State of
        cbUnchecked:
          if AllowGrayed then State := cbGrayed else State := cbChecked;
        cbChecked: State := cbUnchecked;
        cbGrayed: State := cbChecked;
      end;
    end;
end;

end.
